LINUX下将mysql从5.1升级至5.5后,发现存储过程不能用了。创建和使用存储过程时就会提示Cannot load from mysql.proc. The table is probably corrupted

查遍整个百度,结果还是印证了那一句话“天下文章一大抄”啊!

所有的文章几乎都是这么说的

解决方法非常简单,运行mysql_upgrade命令即可。此命令会在数据目录下生成一个文本文件mysql_upgrade_info,里面的内容为升级后的数据库版本。

但不知道什么原因,我这里无效,升级后各种升级OK,但仍然报这个错误。

最后还是求助GOOGLE吧

http://bugs.mysql.com/bug.php?id=50183

原因是mysql.proc升级时有个字段没有升级成功。

在5.1中mysql.proc表的comment字段是varchar(64):

 `comment` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',

但在5.5中应该是text:

`comment` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,


So,执行下面的语句,把这个字段修改为text,就彻底OK了:
ALTER TABLE `proc`
MODIFY COLUMN `comment`  text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL AFTER `sql_mode`;

								

centos

centos

这个。。虽说是出了新版本,但让我挺郁闷。好不容易把centos5.4下载下来,并配置好了,也就是在我刚配置好的一霎那..看到官方推出了centos5.5版。这也太巧了。
不过总归是很期待这个版本的,RHEL 5.5在3月底就发布了,所以一直想着centos能紧跟,现在过去一个半月发布,也还算是跟得挺紧的。

mirrors.163.com已经有了5.5的更新了,需要的朋友可以直接去下了:http://mirrors.163.com/centos/5.5/isos/

该版本基于 Red Hat Enterprise Linux 5.5,“是 CentOS 5 发行系列的第五次更新。它包含了很多错误修正、升级和新功能”。

有关 CentOS 5.5 的变化详情,可查阅其发 布公告发 行注记